> For the complete documentation index, see [llms.txt](https://docs.lineverge.com/automail/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.lineverge.com/automail/configurations/workflow-configuration/custom-workflows.md).

# Custom Workflows

Custom workflows are used for background tasks that are not covered by [Sync Workflows](/automail/configurations/workflow-configuration/sync-workflows.md).

To stay consistent with the overall project structure, each custom workflow must be within a py file located in the **project** folder.&#x20;

The py file will start with the generic import of components relevant to Automail (e.g. *custom\_models* to access all models, *custom\_functions* to access all project functions, etc.). Each workflow would then be defined within its own function and called in the main as in the example below.

```python
try:
    from _init import * # DEV env
except ImportError:
    from configurations.workflow_env import * # PROD env

def count_delivery_records():
    print("Delivery records:", custom_models.Delivery.objects.all().count())

if __name__ == '__main__':
    count_delivery_records()
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.lineverge.com/automail/configurations/workflow-configuration/custom-workflows.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
